c
c
      implicit double precision(a-b, d-h, o-z)
      implicit integer (i-n)
	implicit double complex (c)
c
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
      common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
c
c     device number of files 
c
      nfidt=10
	nfdat=20
      nfodt=22
	nffrd=24
	nfthd=26
c
c
c     fft.idt: input data file for calculation parameters
c     fft.odt: message output file
c     fft.frd: frequency domain data: Fourier trasformation data
c     fft.thd: including time history data which are calculated by inverse Fourier tranformation
c
	open (nfidt, file = 'fft.idt')
	open (nfodt, file = 'fft.odt')
	open (nffrd, file = 'fft.frd')
	open (nfthd, file = 'fft.thd')
c
c
      refhed = 1.d0 ! no valid
      budwat = 1.d0
      graacc = 1.d0
c
c
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
      pi = 4.d0 * datan(1.d0)
c
c
      call inpref
	call solve_main
c
c
      close (nfidt)
      close (nfodt)
	close (nffrd)
	close (nfthd)
c
c
      stop 7777
c
c
      end
c
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   I N P R E F             **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine inpref
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
	character*30 dataname, dline
	character*8 flag
	character*5 flagname
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Previous investigation of the number of wave data
c     to check up array dimension for ndat. 
c----------------------------------------------------------------------
c
c
c
	rewind(nfidt)
	rewind(nfodt)
c
c
c     /tcinf/
c
  300	read (nfidt,8000,end=999, err=999) flag
	if (flag .ne. '/tcinf/') goto 300
	    read (nfidt,8100) dline
	    read (nfidt,*) tint, nstart, nend
	rewind(nfidt)
c
c
c     /file_flag/
c
 8000	format(a7)
 8100	format(a5)
  800	read (nfidt,8000,end=999, err=999) flag
	if (flag .ne. '/file_f') goto 800
	    read (nfidt,8100) dline
	    read (nfidt,9820) dataname
	    read (nfidt,8100) dline
	    read (nfidt,9840) flagname
c
 9820	    format(15x, a30)
 9840	    format(15x, a5)
	rewind(nfidt)
c
c
c        / Read Data /
c
c
	call readdat_ref(dataname, flagname)
c
c
  777 return
c
c
  999	write(*, 9999) 
 9999 format(' / There are not some flags in IDT-file
     * in subroutine inpref /')
	stop 9999
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   S O L V E  _ M A I N    **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine solve_main
c
c
      implicit double precision(a-b, d-h, o-z)
      implicit integer (i-n)
	implicit double complex (c)
c
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
      common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
c
      allocatable :: datai(:)
      allocate (datai(ndat))
c
c
      refhed = 1.d0
      budwat = 1.d0
      graacc = 1.d0
c
c
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
      pi = 4.d0 * datan(1.d0)
c
c
      do i=1, ndat
          datai(i)=0.d0
	enddo
c
c
      call inpdat(datai)
	call solve_spectrum(datai)
c
c
      deallocate (datai)
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   I N P D A T             **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine inpdat(datai)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
	character*30 dataname, dline
	character*8 flag
	character*5 flagname
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension datai(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Input Data of Acc. Measured or Stress Wave Analyzed
c----------------------------------------------------------------------
c
c
c
	rewind(nfidt)
	rewind(nfodt)
c
c
c     /const/
c
  100	read (nfidt,8000,end=999, err=999) flag
 8000	format(a7)
      if (flag .ne. '/const/') goto 100
	    read (nfidt,8100) dline
 8100	    format(a5)
	    read (nfidt,*) graacc, budwat, refhed
	rewind(nfidt)
c
c
c     /dainf/
c
  200	read (nfidt,8000,end=999, err=999) flag
	if (flag .ne. '/dainf/') goto 200
	    read (nfidt,8100) dline
	    read (nfidt,*) n
	rewind(nfidt)
c
c
c     /tcinf/
c
  300	read (nfidt,8000,end=999, err=999) flag
	if (flag .ne. '/tcinf/') goto 300
	    read (nfidt,8100) dline
	    read (nfidt,*) tint, nstart, nend
	rewind(nfidt)
c
c
c     /flinf/
c
  700	read (nfidt,8000,end=999, err=999) flag
	if (flag .ne. '/flinf/') goto 700
	    read (nfidt,8100) dline
	    read (nfidt,*) ifinp
	    read (nfidt,8100) dline
	    read (nfidt,*) band, offlow, offhigh
	    read (nfidt,8100) dline
	    read (nfidt,*) ncycs
	    read (nfidt,8100) dline
	    read (nfidt,*) nmedianf
	rewind(nfidt)
c
c
c     /file_flag/
c
  800	read (nfidt,8000,end=999, err=999) flag
	if (flag .ne. '/file_f') goto 800
	    read (nfidt,8100) dline
	    read (nfidt,9820) dataname
	    read (nfidt,8100) dline
	    read (nfidt,9840) flagname
	rewind(nfidt)
c
 9820	    format(15x, a30)
 9840	    format(15x, a5)
c
c
c        / Read Data /
c
c
	call readdat(dataname, flagname, datai)
c
c
  777 return
c
c
  999	write(*, 9999) 
 9999 format(' / There are not some flags in IDT-file /')
	stop 9999
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   R E A D D A T _ R E F   **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine readdat_ref(dataname, flagname)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
	character*5 flagname, flag
	character*30 dataname
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     tentative read time history data and counting numebr of data
c----------------------------------------------------------------------
c
c
c     nstart <=1 and nend < 0; all data will be read.
c     nend are > 0; {max(nstart,1), nend} will be read.
c
c
      if (nend .gt. 0) then
	    j=max(nstart, 1)
          ndat=nend-nstart+1
	    return
	else
	    continue
      end if
c
c
	open (nfdat, file = dataname)
      rewind (nfdat)
c
c
c        / Read Data only to count total number of data/
c
  100	read (nfdat, 1000) flag
 1000	format(a5)
	if (flag .ne. flagname) goto 100
c
	do i=1, nstart-1    ! skip lines
	    read (nfdat,*, end=300, err=999) dummy
	enddo
c
      n = 0; d=0.d0
  200 read (nfdat,*, end=300, err=999) dummy
	backspace(nfdat)
      n=n+1
	read (nfdat,*) d
	if ( (nend .gt. 0) .and. (n .eq. nend) ) goto 300
	goto 200
  300 ndat=n
      if (ndat .eq. 0) goto 555
c
c
	close(nfdat)
c
c        / Arrangement of Number of Data to be Power of 2/
c
      i=0
  400 i=i+1
      ndummy=ndat-2**i
      if (ndummy .gt. 0) goto 400 
      if (ndummy .lt. 0) then    ! ndat is less than power of 2
          ndummy=iabs(ndummy)
	    ndat=ndat+ndummy
      else                ! ndat is just equal to power of 2
          ndat=ndat
      end if
c
c
  777 return
c
c
  555 write (nfodt,1100)
      write(*,1100)
 1100 format('** flag do not exit or Data do not exit
     * in readdat_ref **')
	close(nfdat)
      stop 5555
c
c
  999 write (nfodt,1110)
      write(*,1100)
 1110 format('** Read error occurs in readdat_ref **')
	close(nfdat)
     	stop 9999
c
c
      end
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   R E A D D A T           **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine readdat(dataname, flagname, datai)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
	character*5 flagname, flag
	character*30 dataname
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension datai(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     read time history data for acc. measured or stress wave analyzed
c
c----------------------------------------------------------------------
c
c
	open (nfdat, file = dataname)
c
      rewind (nfdat)
c
c
c        / Read Data /
c
  100	read (nfdat, 1000) flag
 1000	format(a5)
	if (flag .ne. flagname) goto 100
c
c
	do i=1, nstart-1   ! skip lines
	    read (nfdat,*, end=300, err=999) dummy
	enddo
      n = 0
  200 read (nfdat,*, end=300, err=999) dummy
	backspace(nfdat)
	n=n+1; datai(n)=0.d0
	read (nfdat,*) datai(n)
	if ( (nend .gt. 0) .and. (nstart+n-1 .eq. nend) ) goto 300
	goto 200
  300 ndat=n
      if (ndat .eq. 0) goto 555
c
c
	close(nfdat)
c
c        / Arrangement of Number of Data to be Power of 2/
c
      i=0
  400 i=i+1
      ndummy=ndat-2**i
      if (ndummy .gt. 0) goto 400
      if (ndummy .lt. 0) then
          ndummy=iabs(ndummy)
          do 500 j=ndat+1, ndat+ndummy
              datai(j)=0.d0
  500     continue
	    ndat=ndat+ndummy
	    goto 777
      else          ! ndummy = 0
          ndat=ndat
      end if
c
c
  777 return
c
c
  555 write (nfodt,1100)
      write(*,1100)
 1100 format('** flag do not exit or Data do not exit in readdat **')
	close(nfdat)
      stop 5555
c
c
  999 write (nfodt,1110)
      write(*,1100)
 1110 format('** Read error occurs in readdat **')
	close(nfdat)
     	stop 9999
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   S O L V E _ S P E C T R U M ******
c*                                                                     *
c***********************************************************************
c
c
      subroutine solve_spectrum(datai)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
c
      dimension datai(ndat)
c
c    dynamic allocation declares
c
      allocatable :: x(:)
      allocatable :: cdat(:)
      allocatable :: amp(:)
      allocatable :: phase(:)
      allocatable :: famp(:)
      allocatable :: pamp(:)
c
      allocate (x(ndat))
      allocate (cdat(ndat))
      allocate (amp(ndat/2+1))
      allocate (phase(ndat/2+1))
      allocate (famp(ndat/2+1))
      allocate (pamp(ndat/2+1))
c
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c
c     ndat: number of input data   
c     datai(): array of input data
c     x(): tentative array <= datai()
c     cdat(): array of Fourier amplitude or inversed time history data
c     amp(): array of total amplitude
c     phase(): array of phase in FT
c     famp(): array of Fourier amplitude
c     pamp(): array of power amplitude
c
c
c

c     Calculate spectrum properties for datai()
c----------------------------------------------------------------------
c
c    
c     ! replace variable
c
	do 100 i=1, ndat
	    x(i)=datai(i)
  100	continue 
c
c     ! FFT analysis and output results 
c
      call opt_fft_dat(x, cdat, amp, famp, pamp, phase)
c
c
c     ! release memories
c
      deallocate (x)
      deallocate (cdat)
      deallocate (amp)
      deallocate (phase)
      deallocate (famp)
      deallocate (pamp)
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   O P T _ F F T _ D A T   **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine opt_fft_dat(x, cdat, amp, famp, pamp, phase)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
	dimension cdat(ndat), nmpeak(2)
      dimension amp(ndat/2+1), phase(ndat/2+1)
	dimension famp(ndat/2+1), pamp(ndat/2+1)
	dimension x(ndat)
c
c
      allocatable :: y(:)
      allocate (y(ndat))
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c     y(): tentative memory
c     arguement in fftc: -1: FT transform from time domain to frequency domain
c                        +1: inverse FT transform from time domain to frequency domain
c
c
c
c
c     FFT and output fast fourier transformed data
c----------------------------------------------------------------------
c
      do i=1, ndat
          y(i)=0.d0
	enddo
c
      call fftc(x, cdat, -1)    
      if (ifinp .gt. 0) then
	    call freqpass(cdat)
      end if
      call ampphs(cdat, amp, famp, pamp, phase)
c
      call msg_name_col
	call opt_fft_frd(amp, famp, pamp, phase)
	call fftc(x, cdat, 1)
	do 100 i=1, ndat
	    y(i)=dble(cdat(i))
  100	continue
      call opt_fft_thd(x, y)
c
c
      deallocate (y)
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   F F T C                 **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine fftc(x, cdat, invt)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension x(ndat), cdat(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c     invt: switch parameter: -1: FT; +1: inverse FT
c
c
c
c
c     Fast Fourier Transform Solver
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat
	    if (invt .gt. 0) then 
            cdat(i)=cdat(i)
	    else
	      cdat(i)=cmplx(x(i), 0.d0)
	    end if
  100 continue
c
  200 call fast(cdat, invt)
      if (invt .gt. 0) goto 777
      do 300 i=1, ndat
          cdat(i)=cdat(i)/dble(ndat)
  300 continue
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E   F A S T                 **********
c*                                                                     *
c***********************************************************************
c
      subroutine fast(cdat, invt)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat, ctemp, ctheta
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension cdat(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Fast Fourier Transform coded by OOSAKI
c----------------------------------------------------------------------
c
c
      j=1
      do 140 i=1, ndat
          if (i .ge. j) goto 110
              ctemp=cdat(j)
              cdat(j)=cdat(i)
              cdat(i)=ctemp
  110         m=ndat/2
  120     if (j .le. m) goto 130
              j=j-m
              m=m/2
          if (m .ge. 2) goto 120
  130         j=j+m
  140 enddo
      kmax=1
  150 if (kmax .ge. ndat) goto 777
      istep=kmax*2
      do 170 k=1, kmax
          ctheta=cmplx(0.d0, pi*dble(invt*(k-1))/dble(kmax))
          do 160 i=k,ndat,istep
              j=i+kmax
              ctemp=cdat(j)*cdexp(ctheta)
		    cdat(j)=cdat(i)-ctemp
              cdat(i)=cdat(i)+ctemp
  160     enddo
  170 enddo
      kmax=istep
      goto 150
c
c
  777 return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    A M P P H S            **********
c*                                                                     *
c***********************************************************************
c
      subroutine ampphs(cdat, amp, famp, pamp, phase)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension cdat(ndat), amp(ndat/2+1), phase(ndat/2+1)
	dimension famp(ndat/2+1), pamp(ndat/2+1)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Amplitudes and phase for Fourier Series 
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat/2+1
c
          amp(i)=cdabs(cdat(i))*2.d0
	    famp(i)=cdabs(cdat(i))*(dble(ndat)*tint)
  	    if ( (i .eq. 1) .or. (i .eq. ndat/2+1) )then
	    	pamp(i)=     famp(i)*famp(i)/(dble(ndat)*tint)
	    else
		   	pamp(i)=2.d0*famp(i)*famp(i)/(dble(ndat)*tint)
	    end if 
c
	    phase(i)=0.d0 
          xcphs =   2.d0*dble(cdat(i))
          xsphs = - 2.d0*dimag(cdat(i))
	    xx    = dsqrt(xcphs*xcphs+xsphs*xsphs)
	    if ( xx .eq. 0.d0 ) goto 100
              xcphs=   xcphs/xx
              xsphs= - xsphs/xx
              if (dabs(xcphs) .ge. dabs(xsphs)) then
                  if (xcphs .ge. 0.d0) then
                      phase(i)=datan(xsphs/xcphs)
                  else
                      phase(i)=datan(xsphs/xcphs) + pi
                  end if
              else
                  if (xsphs .ge. 0.d0) then
                      phase(i)=pi/2.d0-datan(xcphs/xsphs)
                  else
                      phase(i)=pi/2.d0-datan(xcphs/xsphs) + pi
                  end if
              end if
              phase(i)=dmod(phase(i), pi)
c
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    F R E Q P A S S        **********
c*                                                                     *
c***********************************************************************
c
      subroutine freqpass(cdat)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      double complex cdat
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension cdat(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c     offhigh: cut off higher frequency than offhigh: cdat()=0.0
c     offlow : cut off lower frequency than offhigh: cdat()=0.0
c
c
c
c
c     Low or high Pass Filter to cut off frequency 
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat/2+1
	    if (dble(i)/(tint*dble(ndat)) .gt. offhigh) then
			cdat(i)=dcmplx(0.d0, 0.d0)
		end if
	    if (dble(i)/(tint*dble(ndat)) .lt. offlow) then
			cdat(i)=dcmplx(0.d0, 0.d0)
		end if
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    S W I N                **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine swin(famp, pamp, ind)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
      common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension famp(ndat/2+1), pamp(ndat/2+1)
	dimension w(101)
c
c
      allocatable :: g1(:)
      allocatable :: g2(:)
      allocate (g1(ndat))
      allocate (g2(ndat))
c
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c     Smoothed Spectra by Parzen's Spectral Windows
c
c----------------------------------------------------------------------
c
c	  Initialization
c
	do 10 i=1, 101
          w(i)=0.d0
   10	continue
      do 20 i=1, ndat
	    g1(i)=0.d0
	    g2(i)=0.d0
   20	continue
c
	nfold=ndat/2+1
	df=1.d0/(dble(ndat)*tint)
c
      t=1.d0/df
	if (band .eq. 0.d0) goto 120
	    udf=1.854305/band*df
	if (udf .gt. 0.5d0) goto 230 
	    lmax=idint(2.d0/udf)+1 
      if (lmax. gt. 101) goto 240
c
c     Spectral Window
c
      w(1)=3.d0/4.d0*udf
	do 110 l=2, lmax
	    dif=1.570796*dble(l-1)*udf
	    w(l)=w(1)*(dsin(dif)/dif)**4.d0
  110	continue
c
c	Conversion from Fourier to Power Spectrum 
c
  120	if (ind .ne. 100) goto 140
      pamp(1)=famp(1)*famp(1)/t
      do 130 k=2, nfold-1
	   	pamp(k)=2.d0*famp(k)*famp(k)/t
  130 continue
      pamp(nfold)=famp(nfold)*famp(nfold)/t
c
c	Smoothing of Power Spectrum
c
  140 if (band .eq. 0.d0) goto 210
	ll=lmax*2-1
	ln=ll-1+nfold
	lt=(ll-1)*2+nfold
	le=lt-lmax+1
	do 150 k=1, lt
	    g1(k)=0.d0
  150	continue
	do 160 k=1, nfold
	    g1(ll-1+k)=pamp(k)
  160	continue
	do 180 k=lmax, le
	    s=w(1)*g1(k)
	    do 170 l=2, lmax
              s=s+w(l)*(g1(k-l+1)+g1(k+l-1))    
  170     continue
          g2(k)=s
  180	continue
 	do 190 l=2, lmax 
 	    g2(ll+l-1)=g2(ll+l-1)+g2(ll-l+1) 
	    g2(ln-l+1)=g2(ln-l+1)+g2(ln+l-1)
  190 continue
	do 200 k=1, nfold
	    pamp(k)=g2(ll-1+k)
  200 continue
c
c	Smoothed Fourier Spectrum
c
  210 famp(1)=dsqrt(pamp(1)*t)
	do 220 k=2, nfold-1
	    famp(k)=dsqrt(pamp(k)*t/2.d0)
  220 continue
	famp(nfold)=dsqrt(pamp(nfold)*t)
c
c
      deallocate (g1)
      deallocate (g2)
c
c
	return
c
c
  230 write(*,601)
	stop
  240 write(*,602)
	stop
c
c	Format Statements
c
  601 format(' /BANDWIDTH OF SPECTRUM WINDOW IS TOO NARROW')
  602 format(' /BANDWIDTH OF SPECTRUM WINDOW IS TOO WIDE')
c
      end
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    H A N N I N G   W I N   *********
c*                                                                     *
c***********************************************************************
c
c
      subroutine hanning_win(famp, pamp)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
      common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension famp(ndat/2+1), pamp(ndat/2+1)
c
c
      allocatable :: g1(:)
      allocate (g1(ndat))
c
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c     Smoothed Spectra by Hanning's Spectral Windows
c
c----------------------------------------------------------------------
c
c       Initialization 
c  
      nfold=ndat/2+1
	df=1.d0/(dble(ndat)*tint)
c
      do 10 i=1,nfold
	    g1(i)=0.d0
   10	continue
c
      t=1.d0/df
c
c	Smoothing of Power Spectrum
c
  140 g1(1)=0.5d0*pamp(1)+0.5d0*pamp(2)
      do 100 i=2,nfold-1
	    g1(i)=0.25d0*pamp(i-1)+0.5d0*pamp(i)+0.25d0*pamp(i+1)
  100 continue
      g1(nfold)=0.5d0*pamp(nfold)+0.5d0*pamp(nfold-1) 
c      
	do 200 k=1, nfold
	pamp(k)=g1(k)
  200 continue
c
c	Smoothed Fourier Spectrum
c
  210 famp(1)=dsqrt(pamp(1)*t)
	do 220 k=2, nfold-1
	    famp(k)=dsqrt(pamp(k)*t/2.d0)
  220 continue
	famp(nfold)=dsqrt(pamp(nfold)*t)
c
c
      deallocate (g1)
c
	return
c
c
  230 write(*,601)
	stop
  240 write(*,602)
	stop
c
c	Format Statements
c
  601 format(' /BANDWIDTH OF SPECTRUM WINDOW IS TOO NARROW')
  602 format(' /BANDWIDTH OF SPECTRUM WINDOW IS TOO WIDE')
c
      end
c
c
c
c***************************************************************************
c*                                                                         *
c**********     S U B R O U T I N E    M E D I A N   F I L T E R   *********
c*                                                                         *
c***************************************************************************
c
c
      subroutine median_filter(famp, pamp)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
      common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension famp(ndat/2+1), pamp(ndat/2+1)
      dimension g3(nmedianf), g4(nmedianf)
c
c
      allocatable :: g1(:)
      allocatable :: g2(:)
	allocate (g1(ndat))
     	allocate (g2(ndat))
c
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c     Smoothed Spectra by Median filter
c
c----------------------------------------------------------------------
c
c       Initialization 
c  
      g1=0.d0; g2=0.d0
c
      nfold=ndat/2+1
	df=1.d0/(dble(ndat)*tint)
c
      do 10 i=1,nfold
	    g1(i)=0.d0
   10	continue
c
      t=1.d0/df
c
c	Smoothing of Power Spectrum
c
      nd=int((nmedianf-1)/2)
      do i=1, nd
          g1(i)=pamp(i)
      enddo
      do i=(nfold-nd)+1, nfold
          g1(i)=pamp(i)
      enddo
c
      do i=nd+1,nfold-nd
	    g3=0.d0
	    j1=i-nd; j2=i+nd
	    do j=1, nmedianf
	        k=j1+(j-1)
	        g3(j)=pamp(k)
	    end do
	    n=100
	    do while (n .ne. 0) 
              n=0
		    do j=1, nmedianf-1
                  if ( g3(j) > g3(j+1) ) then
			        call swap(g3(j), g3(j+1))
                      n=n+1
			    endif
		    enddo
	        continue
	    end do
          j=(nmedianf-1)/2+1
	    g1(i)=g3(j)
      end do
c
c
c
	do 200 i=1, nfold
	    pamp(i)=g1(i)
  200 continue
c
c	Smoothed Fourier Spectrum
c
  210 famp(1)=dsqrt(pamp(1)*t)
	do 220 k=2, nfold-1
	    famp(k)=dsqrt(pamp(k)*t/2.d0)
  220 continue
	famp(nfold)=dsqrt(pamp(nfold)*t)
c
c
      deallocate (g1)
      deallocate (g2)
c
	return
c
c
  230 write(*,601)
	stop
  240 write(*,602)
	stop
c
c	Format Statements
c
  601 format(' /BANDWIDTH OF SPECTRUM WINDOW IS TOO NARROW')
  602 format(' /BANDWIDTH OF SPECTRUM WINDOW IS TOO WIDE')
c
      end
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    S W A P                **********
c*                                                                     *
c***********************************************************************
c
      subroutine swap(p, q)
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
      common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      r=p
	p=q
	q=r
c
      end
c
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    F I L T E R C U T      **********
c*                                                                     *
c***********************************************************************
c
      subroutine filtercut(famp, cx)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c) 
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
	dimension famp(ndat/2+1), cx(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     filterization of frequency range data by cuting off data with lower and higher frequency
c
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat
	    freq=dble(i)/(dble(ndat)*tint)
	    if (i .le. (ndat/2+1)) then
	        j=i
	        if ((freq .lt. offlow) .or. (freq .gt. offhigh)) then
				cx(i)=0.d0
	            goto 100
              end if
	    else
	        j=ndat-i+2
	    end if
	    if (cdabs(cx(i)) .eq. 0.d0) goto 100
	    cx(i)=cx(i)*famp(j)/(dble(ndat)*tint)/cdabs(cx(i))
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    O P T T H D            **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine opt_fft_thd(x, y)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
      implicit double complex (c)
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension x(ndat), y(ndat)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Time histries of Original Data and 
c                      Inverse Fourier Transformed Data with Filteration and Smoothing
c----------------------------------------------------------------------
c
c
      do 100 i=1, ndat
          write (nfthd, 1100) i-1, dble(i-1)*tint, x(i), y(i)
 1100	    format(i5, ', ', 2(e15.7, ', '), e15.7)
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    O P T F R D            **********
c*                                                                     *
c***********************************************************************
c
      subroutine opt_fft_frd(amp, famp, pamp, phase)
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
	common /dainf/ ndat, nstart, nend
      common /tcinf/ tint, tstart
	common /flinf/ band, offhigh, offlow, ifinp, ncycs, nmedianf
c
      dimension amp(ndat/2+1), phase(ndat/2+1)
	dimension famp(ndat/2+1), pamp(ndat/2+1)
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Output of Frequency Range Data with smoothing operations 'ifinp'
c
c
c     ifinp: smoothing operation number for frequency domain
c            1: Parzen window; 2: Hanning window; 3: Median value filter
c            4: Median value filter & Hanning window
c
c----------------------------------------------------------------------
c
c     Smoothing
c
      if (ifinp .eq. 1) then              ! with Parzen window
	    do i=1, ncycs
	        call swin(famp, pamp, 110)  
          enddo
	end if
      if (ifinp .eq. 2) then             ! with Hanning window
	    do i=1, ncycs
              call hanning_win(famp, pamp)
		enddo
	end if
      if (ifinp .eq. 3) then             ! with Median filter
              call median_filter(famp, pamp)
	end if
      if (ifinp .eq. 4) then             ! with Median filter and Hanning window
          call median_filter(famp, pamp)
	    do i=1, ncycs
              call hanning_win(famp, pamp)
		enddo
	end if
c
      do 100 i=1, ndat/2+1
	    freq=dble(i-1)/(dble(ndat)*tint)
		if (i .eq. 1) then
	        period=999.d0
		else
	        period=1.d0/freq
		endif
          write (nffrd, 1200) i,freq, period, amp(i), 
     1	                    famp(i), pamp(i), phase(i)*180.d0/pi
 1200	    format(i5, ', ', 5(e15.7, ', '), e15.7)
  100 continue
c
c
      return
c
c
      end
c
c
c***********************************************************************
c*                                                                     *
c**********     S U B R O U T I N E    M S G N C V            **********
c*                                                                     *
c***********************************************************************
c
c
      subroutine msg_name_col
c
c
      implicit double precision (a-b, d-h, o-z)
      implicit integer (i-n)
c
c
      common /const/ graacc, budwat, refhed
      common /fnumb/ nfidt, nfdat, nfodt, nffrd, nfthd
c
c
      pi = 4.d0 * datan(1.d0)
      prsref = refhed * budwat * graacc
      focref = budwat * graacc
c
c
c     Message of names of variable columns
c----------------------------------------------------------------------
c
c
      write (nfthd, 1000)
      write (nffrd, 1010)
c
 1000 format('  No., Time, Original time histroy data,
     *        inverse transformed data ')
c
 1010 format('  No., Freq., Period., Amp., F.Amp., P.Amp., Phase')
c
c
      return
c
c
      end
c
c
